/*--------------------------------------------------------------------------
 * Copyright (C) 1992,1993,1994,1995,1996,1997,1998,1999 Dallas Semiconductor 
 * Corporation. All rights Reserved. Printed in U.S.A.
 * This software is protected by copyright laws of
 * the United States and of foreign countries.
 * This material may also be protected by patent laws of the United States 
 * and of foreign countries.
 * This software is furnished under a license agreement and/or a
 * nondisclosure agreement and may only be used or copied in accordance
 * with the terms of those agreements.
 * The mere transfer of this software does not imply any licenses
 * of trade secrets, proprietary technology, copyrights, patents,
 * trademarks, maskwork rights, or any other form of intellectual
 * property whatsoever. Dallas Semiconductor retains all ownership rights.
-----------------------------------------------------------------------------*/
// Psion Demo.c V3.11Beta

#include <plib.h>
#include <p_serial.h>
#include <p_keyb.h>


#define TMEXUTIL
#include "Tmexutil.H" 
#include "tmexinc.h"
#define CBR_19200 19200
#define CBR_9600 9600

//necessary to see output on workabout
#define SCREENWIDTH 40
#define SCREENHEIGHT 9
unsigned char state_buf[5125];
GLDEF_D P_RECT _DefScreenRect = {0,0,SCREENWIDTH,SCREENHEIGHT};


GLDEF_C main()
{
   char buf[200];
   short flag,i,didsetup=0;
   short ROM[9];
   short PortNum=0,PortType=5;
   long SHandle;
   char key = 'y';
   short count=0;     
   
   // get the TMEX driver version
   p_printf("PSION DEMO Version 3.11");
   p_printf("Dallas Semiconductor Corporation");
   p_printf("Copyright (C) 1992-1999");
   
   p_printf("Port number: %d ", PortNum);
   Get_Version(&buf[0]);
   p_printf("PSION TMEX Version:");
   p_printf("%s",buf);
   p_printf("-- More --");
   p_getch();
  
   // loop to display the rom numbers until 'n'
   do
   {
     
      // get a session handle to the requested port
      SHandle = TMExtendedStartSession(PortNum,PortType,NULL);
      
      if (SHandle > 0)
      {
         // check to see if TMSetup has been done once
         if (!didsetup)
         {
            flag = TMSetup(SHandle);
            
            if (flag == 1 || flag == 2)
            {
               p_printf("TMSetup complete %d",flag);
               didsetup = 1;
            }
            else
            {
               p_printf("ERROR doing setup %d",flag);
               p_printf("-- More --");
               p_getch();

               break;
            }
         }
         // only get the next rom after setup complete
         else
         {
            flag = TMNext(SHandle,&state_buf[0]);
           
            // if part found print Rom ID
            if (flag > 0)
            {
               count++;
               ROM[0] = 0;
               flag = TMRom(SHandle,&state_buf[0],&ROM[0]);
               
               for (i = 7; i >= 0; i--)
                  p_print("%02x ",ROM[i]);
               p_printf("");
            }
            else
            {
               p_printf("Total Parts Found %d", count);
               p_printf("end of search");
               p_printf("Search One Wire Net (y/n)");
               key = p_getch();
               count = 0;
            }
         }//else setup complete

         // close the opened session 
         TMEndSession(SHandle);
      }// if Session > 0
   } 
   while (key != 'n');

   p_printf("PSION Demo end");
   return(1);

}


