/*--------------------------------------------------------------------------
 * Copyright (C) 1999 Dallas Semiconductor Corporation.
 * All rights Reserved. Printed in U.S.A.
 * This software is protected by copyright laws of
 * the United States and of foreign countries.
 * This material may also be protected by patent laws of the United States
 * and of foreign countries.
 * This software is furnished under a license agreement and/or a
 * nondisclosure agreement and may only be used or copied in accordance
 * with the terms of those agreements.
 * The mere transfer of this software does not imply any licenses
 * of trade secrets, proprietary technology, copyrights, patents,
 * trademarks, maskwork rights, or any other form of intellectual
 * property whatsoever. Dallas Semiconductor retains all ownership rights.
 *--------------------------------------------------------------------------
 *
 *  TMEXINC.H
 *  Header for TMEX Psion.
 */
#define ulong unsigned long
#define short int

/* Sesssion */
extern long  TMExtendedStartSession(short, short, void *);
extern long  TMStartSession(short);
extern short TMValidSession(long);
extern short TMEndSession(long);

/* File */
extern short TMFirstFile(long,void *,FileEntry *);
extern short TMNextFile(long,void *,FileEntry *);
extern short TMOpenFile(long,void *,FileEntry *);
extern short TMCreateFile(long,void *,short *,FileEntry *);
extern short TMCloseFile(long,void *,short);
extern short TMReadFile(long,void *,short,unsigned char *,short);
extern short TMWriteFile(long,void *,short,unsigned char *,short);
extern short TMDeleteFile(long,void *,FileEntry *);
extern short TMFormat(long,void *);
extern short TMAttribute(long,void *,short,FileEntry *);
extern short TMReNameFile(long,void *,short,FileEntry *);
extern short TMChangeDirectory(long,void *,short,DirectoryPath *);
extern short TMDirectoryMR(long,void *,short,FileEntry *);
extern short TMCreateProgramJob(long,void *);
extern short TMDoProgramJob(long,void *);
extern short TMWriteAddFile(long,void *,short,short,unsigned char *,short);
extern short TMTerminateAddFile(long,void *,FileEntry *);


/* Transport */
extern short TMReadPacket(long,void *,short,unsigned char *,short);
extern short TMWritePacket(long,void *,short,unsigned char *,short);
extern short TMBlockIO(long,void *,unsigned char *,short);
extern short TMExtendedReadPage(long,void *,short,unsigned char *,short);
extern short TMProgramByte(long,void *,short,short,short,short *,short);

/* Network */
extern short TMFirst(long,void *);
extern short TMNext(long,void *);
extern short TMAccess(long,void *);
extern short TMStrongAccess(long,void *);
extern short TMStrongAlarmAccess(long,void *);
extern short TMRom(long,void *,short *);
extern short TMFirstAlarm(long,void *);
extern short TMNextAlarm(long,void *);
extern short TMFamilySearchSetup(long,void *,short);
extern short TMSkipFamily(long,void *);
extern short TMAutoOverDrive(long,void *,short);

/* Version */
extern short Get_Version(char *);

/* Hardware Specific */
extern short TMSetup(long);
extern short TMTouchByte(long, short);
extern short TMTouchReset(long);
extern short TMTouchBit(long, short);
extern short TMClose(long);
extern short TMProgramPulse(long); 
extern short TMOneWireCom(long, short, short); 
extern short TMOneWireLevel(long, short, short, short); 
extern short TMGetTypeVersion(short, char *); 
extern short TMBlockStream(long, uchar *, short);


